#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "general.h"

/*

imelody2nokia - Copyright 2001 Michael Kohn (mike@naken.cc)
This falls under the Kohnian license.  Please read
it at http://nakentone.naken.cc/

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int pushback=-1;

int main (int argc, char *argv[])
{
FILE *in;
char filename[1024];
char songname[16];
char song[1024];
int t,l,ptr,ch;
int b,scale,count,a0,b0;
int length,tone,octave,modifier;
int tone_modifier,ats;
int higher,default_octave;
int warning,full_sms_size;
int headers;

  count=0;
  stackptr=0;
  bitptr=7;
  scale=-1;
  b=140;
  ats=1;
  higher=0;
  default_octave=1;
  warning=0;
  full_sms_size=SMS_SIZE;
  headers=1;

  if (argc<2)
  {
    printf("\nimelody2nokia "VERSION" - Convert Ericsson imelody files to Nokia.\n");
    printf(COPYRIGHT);
    printf("Usage: imelody2nokia [ options ] <input filename>\n");
    printf("       -o [ Make song 1 octave higher ]\n");
    printf("       -x [ remove //SCKL header ]\n");
    printf("       -u [ only user-data-header (8bit) ]\n");
    printf("       -k [ include user-data-header and //SCKL ]\n");
    printf("       -s <sms size> [ Maximum size of SMS message (default %d)]\n",SMS_SIZE);
    printf("       -t <tempo (default: %d)>\n",b);
    printf("       -a [force imelody2nokia to ignore @'s in song]\n\n");
    exit(0);
  }

  for (t=1; t<argc; t++)
  {
    if (strcmp(argv[t],"-o")==0)
    { higher=1; }
      else
    if (strcmp(argv[t],"-s")==0)
    { full_sms_size=atoi(argv[++t]); }
      else
    if (strcmp(argv[t],"-a")==0)
    { ats=0; }
      else
    if (strcmp(argv[t],"-x")==0)
    { headers=0; }
      else
    if (strcmp(argv[t],"-k")==0)
    { headers=2; }
      else
    if (strcmp(argv[t],"-u")==0)
    { headers=3; }
      else
    if (strcmp(argv[t],"-t")==0)
    { 
      b=atoi(argv[++t]);
    }
      else
    { strncpy(filename,argv[t],1023); }
  }


  in=fopen(filename,"r");
  if (in==0)
  {
    printf("Could not open file for reading: %s\n",filename);
    exit(0);
  }

  push(2,8);   /* ring tone commands */
  push(74,8);
  push(29,7);

  ptr=0;
  while ((ch=getc(in))!=EOF)
  { song[ptr++]=ch; }

  song[ptr]=0;
  fclose(in);

  l=0;
  while (song[l]!=':' && l<15)
  {
    songname[l]=song[l++];
  }

  songname[l]=0;

  push(1,3);   /* song type */
  push(l,4);   /* length of song name */

  printf("\nimelody2nokia "VERSION" - Convert Ericsson imelody files to Nokia.\n");
  printf(COPYRIGHT);

  printf("\n       Song Name: %s\n",songname);

  for (t=0; t<l; t++)
  { push(songname[t],8); }

  push(1,8);   /* 1 song pattern */
  push(0,3);   /* pattern header id */
  push(0,2);   /* A-part */
  push(0,4);  /* loop 0 times */

  printf("Beats Per Minute: %d\n",b);

  a0=stackptr;
  b0=bitptr;
  push(0,8);

  t=get_tempo(b);
  push(4,3);  /* set tempo */
  push(t,5);
  count++;

  push(3,3);       /* set style */
  push(0,2);       /* set to normal. can rtttl do others? */
  count++;

  push(5,3);       /* set volume */
  push(VOLUME,4);
  count++;

  l=0;
  while (song[l]!=':' && l<ptr) l++;
  l++;
 
  for (t=l; t<ptr; t++)
  {
    if (song[t]=='r') song[t]='p';
    if (song[t]=='R') song[t]='P';
  }
 
  while (l<ptr)
  {
    if (song[l]==' ' || song[l]=='\t' || song[l]=='\r' || song[l]=='\n')
    { l++; continue; }

    if (song[l]=='@' && ats==0)
    { l++; continue; }

    if (song[l]=='*')
    {
      l++;
      default_octave=(song[l++]-'0')-3;
    }

    if (song[l]=='+' && song[l+1]=='+') { octave=2+default_octave; l=l+2; }
      else
    if (song[l]=='+') { octave=1+default_octave; l++; }
      else
    { octave=default_octave; }

    tone_modifier=0;

    if (song[l]=='#')
    {
      tone_modifier=tone_modifier+1;
      l++;
    }

    if (song[l]=='&' || song[l]=='@')
    {
      tone_modifier=tone_modifier-1;
      l++;
    }

    if (song[l]=='(' && song[l+1]=='b' && song[l+2]==')')
    {
      tone_modifier=tone_modifier-1;
      l=l+3;
    }

    if (tolower(song[l])=='a') tone=10; 
      else
    if (tolower(song[l])=='h' || tolower(song[l])=='b') tone=12;
      else
    if (tolower(song[l])=='c') tone=1;
      else
    if (tolower(song[l])=='d') tone=3;
      else
    if (tolower(song[l])=='e') tone=5;
      else
    if (tolower(song[l])=='f') tone=6;
      else
    if (tolower(song[l])=='g') tone=8;
      else
    if (tolower(song[l])=='p') tone=0;

    if (song[l]>='a' && song[l]<='z') length=3;
      else
    if (song[l]>='A' && song[l]<='Z') length=2;

    if (song[l]=='p')
    {
      if (song[l+1]=='p' && song[l+2]=='p' && song[l+3]=='p')
      { length=1; l=l+4; }
        else
      if (song[l+1]=='p')
      { length=2; l=l+2; }
        else
      { l++; }
    }
      else
    { l++; }

    if (song[l]=='.')
    {
      modifier=1;
      l++;
    }

    if (song[l]>='0' && song[l]<='3')
    {
      if (song[l]=='0') 
      { modifier=1; length=2; } 
        else
      if (song[l]=='1') 
      { modifier=0; length=2; } 
        else
      if (song[l]=='2') 
      { modifier=1; length=3; } 
        else
      if (song[l]=='3') 
      { modifier=0; length=3; } 

      l++;
    }

    tone=tone+tone_modifier;

    if (scale!=octave)
    {
      if (octave==5) warning++;
      scale=octave;
      push(2,3);
      push(octave+higher,2);
      count++;
    }

    modifier=0;

    if (song[l]=='.')
    {
      modifier=1;
      l++;
    }

    push(1,3);
    push(tone,4);
    push(length,3);
    push(modifier,2);
    count++;
  }

  if (bitptr!=7) stackptr++;
  push(0,8);

  push_addr(count,8,a0,b0);

  print_codes(full_sms_size,"1581",headers);

  if (warning!=0 && higher==0)
  {
    printf("Warning: Song uses lower octave.  Please read docs on the -o option.
\n");
  }

  printf("\n");

  return (0);
}



